; =====================================================================
; Rough Text - yet another silly script from WWWWolf
; =====================================================================
; Copyright (c) Urpo Lankinen 12.7.1997
;  Distributed under GPL. Permission granted to distribute this script
;  with *anything* that has *something* to do with The GIMP.
; =====================================================================
;
; E-mail: <wwwwolf@iki.fi> Homepage: <URL:http://www.iki.fi/wwwwolf/>
;
; $Id: roughtext.scm,v 1.3.1.0 2000/10/24 09:15:48 wwwwolf Exp wwwwolf $
;
; This was made just to demonstrate some things. Not extremely
; excellent script, but hey, it works...

;Font size:1000 Spread amount:85 Threshold 130
;Font size:1000 Spread amount:100 Threshold 145

(define (script-fu-rough-text text font size amount trsh)
  (let* ((old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (tmp (car (gimp-palette-set-foreground '(  0   0   0))))	;add
	 (tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add
	 (img (car (gimp-image-new 256 256 GRAY)))
	 (text-layer (car (gimp-text-fontname img -1 0 0 text 10 TRUE
					      size PIXELS font)))
	 (bg-layer (car (gimp-layer-copy text-layer 0)))
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

;;2.4ǉ
	 (newlayer)
)

    (gimp-image-undo-disable img)
    (gimp-layer-set-name text-layer "Text")
    (gimp-image-add-layer img bg-layer 2)			;add
    (gimp-layer-set-name bg-layer "Background")
    (gimp-image-resize img width height 0 0)

    (gimp-image-set-active-layer img text-layer)
    (gimp-palette-set-foreground '(0 0 0))

    ; Spread. Repeat x times...?
    (plug-in-spread 1 img text-layer amount amount)
    (plug-in-spread 1 img text-layer (/ amount 2) (/ amount 2))
    (plug-in-gauss-rle 1 img text-layer (* amount 0.8) TRUE TRUE)
    (plug-in-c-astretch 1 img text-layer)
    (gimp-layer-set-preserve-trans text-layer TRUE)

    ; Fill bg with white
    (gimp-image-set-active-layer img bg-layer)
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-selection-all img)
    (gimp-bucket-fill bg-layer 0 0 100 15 FALSE 1 1)
    (gimp-selection-none img)

    (set! newlayer (car (gimp-image-flatten img)))
    (gimp-threshold newlayer trsh 255)

    (gimp-palette-set-background old-bg)
    (gimp-palette-set-foreground old-fg)
    (gimp-image-undo-enable img)
    (gimp-display-new img)))
;
; Hajaa-ho!
;
(script-fu-register
 "script-fu-rough-text" 
 "<Image>/File/Create/Logos/Rough Text..."
 (string-append
 "Creates text that looks like enlarged text from an old typewriter."
 " Based on the \"Rough text\" tutorial by Zach.")
 "Urpo Lankinen <wwwwolf@iki.fi>"
 "Urpo Lankinen <wwwwolf@iki.fi>"
 "1997"
 ""
 SF-STRING "Text String" "Rough Text"
 SF-FONT "Font" "Courier New"
 SF-ADJUSTMENT "Font Size" '(80 2 1000 1 10 0 1)
 SF-ADJUSTMENT "Spread amount" '(3 1 100 1 10 0 0)
 SF-ADJUSTMENT "Threshold" '(150 0 255 1 10 0 0))
