(define (script-fu-slime-logo text size font drip color? bg)
  (let* ((old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (tmp (car (gimp-palette-set-foreground color?)))	;add
	 (img (car (gimp-image-new 256 256 RGB)))
         (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 8) 20) TRUE size PIXELS font)))
         (width (car (gimp-drawable-width text-layer)))
         (height (* (car (gimp-drawable-height text-layer)) 1.3))
;;2.4ǉ
	 (sboub)
)

;; Resize the image
    (gimp-image-resize img width height 0 0)

(script-fu-slime-logocore img text-layer size drip color? bg)

;;㏈
    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
;; display
    (gimp-display-new img)))


(script-fu-register "script-fu-slime-logo"
                    "<Image>/File/Create/Logos/Slime..."
                    "Slime yourself..."
                    "Jean-Philippe Turcat (cmrjpt@soc.staffs.ac.uk)"
                    "Jean-Philippe Turcat"
                    "08/06/1999"
                    ""
		SF-STRING	"Text String"		"Slime Logo"
		SF-ADJUSTMENT	"Font Size (pixels)"	'(120 2 1000 1 10 0 1)
		SF-FONT		"Font"			"Comic Sans MS"
		SF-ADJUSTMENT	"Drip"			'(8 0 100 1 10 0 1)
		SF-COLOR	"Color?"		'(0 0 0)
		SF-COLOR	"Background??"		'(0 0 0)
)


(define (script-fu-slime-logoimg img text-layer size drip color? bg)
  (let* ((old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (tmp (car (gimp-palette-set-foreground color?)))	;add
         (width (* (car (gimp-drawable-width text-layer)) 1.08))
         (height (* (car (gimp-drawable-height text-layer)) 1.3))

;;2.4ǉ
	 (sboub)
)

    (set! height (+ height (- (/ size 2) 40)))		;add

;; Resize the image
    (gimp-image-resize img width height (* width 0.04) (* height 0.05))

(gimp-image-undo-group-start img)
(script-fu-slime-logocore img text-layer size drip color? bg)
(gimp-image-undo-group-end img)

;;㏈
    (gimp-palette-set-foreground old-fg)
    (gimp-palette-set-background old-bg)
;; display
    (gimp-displays-flush)
)
)

(script-fu-register "script-fu-slime-logoimg"
                    "<Image>/Filters/Alpha To Logo/Slime..."
                    "Slime yourself..."
                    "Jean-Philippe Turcat (cmrjpt@soc.staffs.ac.uk)"
                    "Jean-Philippe Turcat"
                    "08/06/1999"
                    "RGB*"
		SF-IMAGE "Image"	0
		SF-DRAWABLE "Drawable"	0
		SF-ADJUSTMENT	"Size (pixels)"	'(120 2 1000 1 10 0 1)
		SF-ADJUSTMENT	"Drip"			'(8 0 100 1 10 0 1)
		SF-COLOR	"Color?"		'(0 0 0)
		SF-COLOR	"Background??"		'(0 0 0)
)


(define (script-fu-slime-logocore img text-layer size drip color? bg)
  (let* ((old-fg (car (gimp-palette-get-foreground)))
	 (old-bg (car (gimp-palette-get-background)))
	 (tmp (car (gimp-palette-set-foreground color?)))	;add
         (width (car (gimp-image-width img)))			;changed
         (height (car (gimp-image-height img)))			;changed
	 (layer1 (car (gimp-layer-new img width height RGBA-IMAGE "Back" 100 NORMAL)))

;;2.4ǉ
	 (sboub)
)

;; put the text white
    (gimp-invert text-layer)
;; put the background black
    (gimp-palette-set-foreground bg)
    (gimp-image-add-layer img layer1 1)
    (if (< size 30)
    (begin
    (gimp-image-resize img width (+ height (* drip 3.7)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 3.7)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 3.7)) 0 0)	;add
    ))
    (if (and (>= size 30) (< size 60))
    (begin
    (gimp-image-resize img width (+ height (* drip 3.5)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 3.5)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 3.5)) 0 0)	;add
    ))
    (if (and (>= size 60) (< size 80))
    (begin
    (gimp-image-resize img width (+ height (* drip 3.3)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 3.3)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 3.3)) 0 0)	;add
    ))
    (if (and (>= size 80) (< size 200))
    (begin
    (gimp-image-resize img width (+ height (* drip 3)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 3)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 3)) 0 0)		;add
    ))
    (if (and (>= size 200) (< size 400))
    (begin
    (gimp-image-resize img width (+ height (* drip 2.5)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 2.5)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 2.5)) 0 0)	;add
    ))
    (if (and (>= size 400) (< size 550))
    (begin
    (gimp-image-resize img width (+ height (* drip 1.5)) 0 0)
    (gimp-layer-resize text-layer width (+ height (* drip 1.5)) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height (* drip 1.5)) 0 0)	;add
    ))
    (if (and (>= size 550) (< size 700))
    (begin
    (gimp-image-resize img width (+ height drip) 0 0)
    (gimp-layer-resize text-layer width (+ height drip) 0 0)	;add
    (gimp-layer-resize layer1 width (+ height drip) 0 0)	;add
    ))
    (if (and (>= size 700) (< size 1001))
    (begin
    (gimp-image-resize img width height 0 0)
    (gimp-layer-resize text-layer width height 0 0)	;add
    (gimp-layer-resize layer1 width height 0 0)		;add
    ))
    (gimp-edit-fill layer1  FG-IMAGE-FILL)
;; merge the text and the bg
    (set! sboub (car (gimp-image-merge-down img text-layer 1)))	;changed 0 to 1

;; rotate the image from 90 degress
    (plug-in-rotate 1 img sboub 1 TRUE)
;; put some wind
    (if (>= drip 1) (plug-in-wind 1 img sboub 10 1 drip 1 1))
;; rotate back
    (plug-in-rotate 1 img sboub 3 TRUE)
;; wave it
    (plug-in-waves 1 img sboub (* (/ size 120) 4) 0 (* (/ size 120) 50) 0 0)
;; blur
    (plug-in-gauss-iir 1 img sboub (* (/ size 120) 5) 1 1)
;; change the color to give the slime
    (gimp-color-balance sboub 0 1 -100 0 -100)
    (gimp-color-balance sboub 2 1 100 0 -10)	;change 10 -10 2.8
    (gimp-color-balance sboub 1 TRUE 0 50 -30)	;add 2.8

)
)
