;;mhTextEffect&mhTextEffectimg
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhTextEffectimg img drawable bgmd bgcolor bggrad bgpat blur depth shadowb xoff opa mrg textblack?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wi
	 (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 NORMAL-MODE)))
	 (bp-layer (car (gimp-layer-new img width height RGB-IMAGE "bumpmap" 100 NORMAL-MODE)))
	 (lcopy (car (gimp-layer-new img width height RGB-IMAGE "lcopy" 100 NORMAL-MODE)))

         (old-bg (car (gimp-palette-get-background)))

;;2.4ǉ
	 (ltext)
	 (ll-layer)
)

;;wiF̌
    (gimp-image-add-layer img bg-layer 1)
    (gimp-palette-set-background bgcolor)
    (gimp-drawable-fill bg-layer BACKGROUND-FILL)
    (cond((= bgmd 1)
       (gimp-gradients-set-gradient bggrad)
       (gimp-blend bg-layer CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE
                                            FALSE 0 0 0 0 0 0 width height))
       ((= bgmd 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern bgpat)
       (gimp-edit-bucket-fill bg-layer PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))

    (gimp-image-add-layer img lcopy 1)
    (gimp-palette-set-background '(255 255 255))
    (gimp-drawable-fill lcopy BACKGROUND-FILL)
    (set! ltext (car (gimp-layer-copy drawable 0)))
    (gimp-image-add-layer img ltext 1)
    (if (= TRUE textblack?)
    (begin
	(gimp-palette-set-background '(0 0 0))
	(gimp-edit-fill ltext BACKGROUND-FILL)
    ))

    (set! ll-layer (car (gimp-image-merge-down img ltext 1)))
    (plug-in-gauss-iir2 1 img ll-layer blur blur)

    (gimp-image-add-layer img bp-layer 0)
    (gimp-palette-set-background '(255 255 255))
    (gimp-drawable-fill bp-layer BACKGROUND-FILL)
    (plug-in-bump-map 1 img bp-layer ll-layer 0 45 depth 0 0 0 0 FALSE FALSE 0)
    (plug-in-colortoalpha 1 img bp-layer '(180 180 180))
    (script-fu-xach-effect img bp-layer -1 -1 '(255 255 255) 66 '(0 0 0) 100 shadowb xoff xoff TRUE)

    (gimp-selection-none img)
    (gimp-image-remove-layer img ll-layer)
    (if (= mrg TRUE) (gimp-image-flatten img))

    (gimp-palette-set-background old-bg)
    (gimp-displays-flush)
))


;摜H{
(define (script-fu-mhTextEffectimgh img drawable bgmd bgcolor bggrad bgpat blur depth shadowb xoff opa mrg)
  (let* (
	(img2 (car (gimp-channel-ops-duplicate img)))
	(drawable2 (car (gimp-image-get-active-layer img2)))
	)
	(gimp-image-undo-disable img2)
	(script-fu-mhTextEffectimg img2 drawable2 bgmd bgcolor bggrad bgpat blur depth shadowb xoff opa mrg FALSE)
	(gimp-image-undo-enable img2)
	(gimp-display-new img2)
  )
)

(script-fu-register "script-fu-mhTextEffectimgh"
		    "<Image>/Script-Fu/MH/TextEffectimg"
		    "mhTextEffectimg"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    "RGB*"
		    SF-IMAGE       "Image"          0
		    SF-DRAWABLE    "Drawable"       0 
                    SF-OPTION      "bg-mode"       '(_"color" _"gradient" _"pattern")
		    SF-COLOR       "Background Color" '(255 255 255)
                    SF-GRADIENT    "Gradient"      "Pastels"
                    SF-PATTERN     "Pattern"       "Pine?"
		    SF-ADJUSTMENT _"Blur"          '(5 1 50 1 2 0 0)
		    SF-ADJUSTMENT _"Depth"         '(18 1 65 1 2 0 0)
		    SF-ADJUSTMENT _"ShadowBlur"    '(5 1 50 1 2 0 0)
		    SF-ADJUSTMENT _"Offset"        '(3 1 30 1 2 0 0)
		    SF-ADJUSTMENT _"Opacity"       '(100 1 100 1 2 0 0)
                    SF-TOGGLE      "Flatten Image"  FALSE)


(define (script-fu-mhTextEffect text size font text-color bgmd bgcolor bggrad bgpat blur depth shadowb xoff opa mrg?)
  (let* ((img (car (gimp-image-new 256 256 RGB)))

;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))
)
(gimp-image-undo-disable img)

;;TCY
    (gimp-image-resize img width height 0 0)
;;OiF̌
    (gimp-palette-set-background text-color)
    (gimp-layer-set-preserve-trans text-layer TRUE)
    (gimp-edit-fill text-layer BACKGROUND-FILL)

;;ق̏Ă
    (script-fu-mhTextEffectimg img text-layer bgmd bgcolor bggrad bgpat blur depth shadowb xoff opa mrg? TRUE)

    (gimp-palette-set-background old-bg)
    (gimp-gradients-set-gradient old-grad)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))

(script-fu-register "script-fu-mhTextEffect"
		    "<Image>/File/Create/Logos/Text Effect..."
		    "mhTextEffect"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    ""
		    SF-STRING      "Text String"      "Text Effect"
		    SF-ADJUSTMENT  "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT        "Font"             "Broadway BT"
		    SF-COLOR       "Text Color"       '(255 140 170)
                    SF-OPTION      "bg-mode"          '(_"color" _"gradient" _"pattern")
		    SF-COLOR       "Background Color" '(200 255 180)
                    SF-GRADIENT    "Gradient"         "Pastels"
                    SF-PATTERN     "Pattern"          "Pine?"
		    SF-ADJUSTMENT _"Blur"          '(5 1 30 1 2 0 0)
		    SF-ADJUSTMENT _"Depth"         '(18 1 65 1 2 0 0)
		    SF-ADJUSTMENT _"ShadowBlur"    '(5 1 50 1 2 0 0)
		    SF-ADJUSTMENT _"Offset"        '(3 1 30 1 2 0 0)
		    SF-ADJUSTMENT _"Opacity"       '(100 1 100 1 2 0 0)
                    SF-TOGGLE      "Flatten Image"  FALSE)
