;;24mhcoral
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-22mhcoral text size font csize thr fgm fcolor fgg fgp bg-md bg-color bggrad bgpat sd? scolor sblur soff)
  (let* ((img (car (gimp-image-new 256 256 RGB)))

;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 10) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
;;wiȂ
	 (bg-layer (car (gimp-layer-new img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) RGB-IMAGE "Background" 100 NORMAL)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
)
(gimp-image-undo-disable img)
;;TCY
	(gimp-image-resize img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))

	(script-fu-22mhcoralimg img text-layer csize thr fgm fcolor fgg fgp bg-md bg-color bggrad bgpat sd? scolor sblur soff TRUE)

	(gimp-palette-set-foreground old-fg)
	(gimp-gradients-set-active old-grad)
	(gimp-patterns-set-pattern old-pat)

	(gimp-image-undo-enable img)
	(gimp-display-new img)
))

(script-fu-register "script-fu-22mhcoral"
		    "<Image>/File/Create/Logos/Coral..."
		    "22mhcoral"
		    "Kiki"
		    "Kiki"
		    "2006/4"
		    ""
		    SF-STRING   "Text String"		"coral"
		    SF-ADJUSTMENT "Font Size (pixels)"	'(120 2 1000 1 10 0 1)
		    SF-FONT     "Font"			"Fillmore"
		    SF-ADJUSTMENT "c-size"              '(2.0 0.1 3.5 0.1 0.2 1 0)
		    SF-ADJUSTMENT  "threshold"		'(80 50 150 1 2 0 0)
                    SF-OPTION	"f-mode"		'(_"color" _"gradient" _"pattern")
		    SF-COLOR    "Color"			'(183 60 29)
		    SF-GRADIENT	"Gradient"		"Purples"
		    SF-PATTERN 	"Pattern"		"Red Cubes"
                    SF-OPTION	"bg-mode"		'(_"color" _"gradient" _"pattern")
		    SF-COLOR    "Background Color"	'(215 218 255)
		    SF-GRADIENT	"Background Gradient"	"Horizon 2"
		    SF-PATTERN 	"Background Pattern"	"Ice"
                    SF-TOGGLE   "Shadow"		TRUE
		    SF-COLOR    "Shadow Color"		'(32 12 12)
		    SF-ADJUSTMENT  "shadowblur"		'(2 0 100 1 2 0 1)
		    SF-ADJUSTMENT  "shadowoffset"	'(1 0 100 1 2 0 1)
)

(define (script-fu-22mhcoralimg img drawable csize thr fgm fcolor fgg fgp bg-md bg-color bggrad bgpat sd? scolor sblur soff text?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
;;wiȂ
	 (bg-layer (car (gimp-layer-new img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) RGB-IMAGE "Background" 100 NORMAL)))
         (text-s (car (gimp-layer-new img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) RGBA-IMAGE "text-s" 100 NORMAL-MODE)))
         (colork (car (gimp-layer-new img (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) RGBA-IMAGE "colork" 100 ADDITION-MODE)))

	 (csize (- 3.6 csize))

	 (snoise (car (gimp-image-new (* csize width) (* csize height) RGB)))
;;snoiselayer
         (slayer (car (gimp-layer-new snoise (* csize width) (* csize height) RGBA-IMAGE "map" 100 NORMAL-MODE)))

         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))

;;2.4ǉ
	 (tcopy)
	 (tcopys)
	 (tkansei)
	 (shdw)
	 (shou)
)
	(gimp-undo-push-group-start img)

	(gimp-layer-resize drawable (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (+ soff (* sblur 0.55)) (+ soff (* sblur 0.55)))	;important

	(if (= FALSE text?) (set! colork (car (gimp-layer-copy drawable 0))))

	(gimp-image-add-layer snoise slayer 0)
	(gimp-selection-all snoise)
	(gimp-palette-set-foreground '(255 255 255))
	(gimp-drawable-fill slayer FG-IMAGE-FILL)
	(gimp-selection-none snoise)
	(plug-in-noisify 1 snoise slayer 0 1 1 1 0)
	(plug-in-noisify 1 snoise slayer 0 1 1 1 0)
	(plug-in-noisify 1 snoise slayer 0 1 1 1 0)
	(plug-in-gauss-iir2 1 snoise slayer 5 5)
	(gimp-image-scale snoise (+ width soff) (+ height soff))
	(gimp-edit-copy slayer)
	(gimp-image-add-layer img text-s 0)
;	(gimp-edit-clear text-s)			;add	;none
	(let ((floating-sel (car (gimp-edit-paste text-s FALSE))))
	  (gimp-floating-sel-anchor floating-sel))

	(gimp-invert text-s)
	(gimp-brightness-contrast text-s 30 40)		;2.4 changed
	(gimp-selection-layer-alpha drawable)
	(gimp-selection-invert img)
	(gimp-edit-clear text-s)
	(gimp-selection-none img)

	(set! tcopy (car (gimp-layer-copy text-s 0)))
	(gimp-image-add-layer img tcopy 0)
	(set! tcopys (car (gimp-layer-copy text-s 0)))

	(gimp-threshold tcopy thr 255)
	(gimp-by-color-select tcopy '(0 0 0) 25 REPLACE TRUE TRUE 0 FALSE)
	(gimp-edit-clear text-s)
	(gimp-selection-none img)
	(gimp-image-remove-layer img tcopy)
	(gimp-image-remove-layer img drawable)
	(plug-in-noisify 1 img text-s 0 0.15 0.15 0.15 0)
	(gimp-brightness-contrast text-s 0 20)

	(gimp-image-add-layer img colork 0)
(if (= TRUE text?)
(begin
	(gimp-palette-set-foreground fcolor)
	(gimp-drawable-fill colork FG-IMAGE-FILL)
    (cond((= fgm 1)
       (gimp-gradients-set-active fgg)                      ;Of[V̐ݒ
       (gimp-blend colork CUSTOM NORMAL LINEAR 100 20 REPEAT-NONE FALSE 0 0 0 0 0 0 0 height))
    ((= fgm 2)
       (gimp-selection-all img)
       (gimp-patterns-set-pattern fgp)
       (gimp-bucket-fill colork PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
       (gimp-selection-none img)
       ))
))
	(if (= FALSE text?) (gimp-layer-set-mode colork ADDITION))
	(gimp-layer-set-opacity colork 75)
	(set! tkansei (car (gimp-image-merge-down img colork 0)))

	(gimp-image-add-layer img tcopys 0)
	(gimp-selection-layer-alpha tkansei)
	(gimp-selection-invert img)
	(gimp-edit-clear tcopys)
	(gimp-selection-none img)
	(gimp-layer-set-opacity tcopys 80)
	(gimp-layer-set-mode tcopys OVERLAY)

;wi
	(gimp-image-add-layer img bg-layer 2)
	(gimp-palette-set-foreground bg-color)
	(gimp-drawable-fill bg-layer FG-IMAGE-FILL)
    (cond((= bg-md 1)
	(gimp-gradients-set-active bggrad)
	(gimp-blend bg-layer CUSTOM NORMAL LINEAR 100 20 REPEAT-NONE
					 FALSE 0 0 0 0 0 0 width height))
	((= bg-md 2)
	(gimp-selection-all img)
	(gimp-patterns-set-pattern bgpat)
	(gimp-bucket-fill bg-layer PATTERN-BUCKET-FILL NORMAL 100 255 FALSE 0 0)
	(gimp-selection-none img)
	))

;e
	(if (= sd? TRUE)
	(begin
	(set! shdw (car (gimp-layer-copy tkansei 0)))
	(gimp-image-add-layer img shdw 2)
	(gimp-selection-all img)
	(gimp-edit-clear shdw)
	(gimp-selection-layer-alpha tkansei)
	(gimp-palette-set-foreground scolor)
	(gimp-edit-fill shdw FG-IMAGE-FILL)
	(gimp-selection-none img)
	(gimp-layer-translate shdw soff soff)	;moved
	(if (> sblur 0) (plug-in-gauss-iir2 1 img shdw sblur sblur))
	(gimp-layer-set-opacity shdw 60)
	))

    (set! width (car (gimp-drawable-width bg-layer)))		;add
    (set! height (car (gimp-drawable-height bg-layer)))		;add
    (if (>= soff sblur ) (set! shou sblur)			;add
	(set! shou soff)					;add
    )								;add
    (gimp-image-resize img (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add
    (gimp-layer-resize bg-layer (- width (/ shou 2))  (- height (/ shou 2)) (- 0 (/ shou 2)) (- 0 (/ shou 2)))	;add

;	(if (= ft? TRUE)
;	(gimp-image-merge-visible-layers img 0)
;	)

	(gimp-image-delete snoise)

	(gimp-palette-set-foreground old-fg)
	(gimp-gradients-set-active old-grad)
	(gimp-patterns-set-pattern old-pat)

	(gimp-undo-push-group-end img)
	(gimp-displays-flush)
))


;摜H{
(define (script-fu-22mhcoralimgh img drawable csize thr bg-md bg-color bggrad bgpat sd? scolor sblur soff)
  (let* (
	(img2 (car (gimp-channel-ops-duplicate img)))
	(drawable2 (car (gimp-image-get-active-layer img2)))
;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))
         (old-grad (car (gimp-gradients-get-active)))
         (old-pat (car (gimp-patterns-get-pattern)))
	)
	(gimp-image-resize img2 (+ (+ width soff) (* sblur 1.1)) (+ (+ height soff) (* sblur 1.1)) (/ (* sblur 1.1) 2) (/ (* sblur 1.1) 2))
	(script-fu-22mhcoralimg img2 drawable2 csize thr 0 '(0 0 0) old-grad old-pat bg-md bg-color bggrad bgpat sd? scolor sblur soff FALSE)
	(gimp-display-new img2)
  )
)

(script-fu-register "script-fu-22mhcoralimgh"
		    "<Image>/Script-Fu/MH/coral"
		    "22mhcoralimg"
		    "Kiki"
		    "Kiki"
		    "2006/4"
		    "RGB*"
		    SF-IMAGE    "Image"			0
		    SF-DRAWABLE "Drawable"		0
		    SF-ADJUSTMENT "c-size"              '(2.0 0.1 3.5 0.1 0.2 1 0)
		    SF-ADJUSTMENT  "threshold"		'(80 50 150 1 2 0 0)
                    SF-OPTION	"bg-mode"		'(_"color" _"gradient" _"pattern")
		    SF-COLOR    "Background Color"	'(215 218 255)
		    SF-GRADIENT	"Background Gradient"	"Horizon 2"
		    SF-PATTERN	"Background Pattern"	"Ice"
                    SF-TOGGLE   "Shadow"		TRUE
		    SF-COLOR    "Shadow Color"		'(32 12 12)
		    SF-ADJUSTMENT  "shadowblur"		'(2 0 100 1 2 0 1)
		    SF-ADJUSTMENT  "shadowoffset"	'(1 0 100 1 2 0 1)
)
