;;mhfire&mhfireimg
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhfire-img img drawable text-gradient hachou sinpuku tblur lmode gmode gg merge? text?)
  (let* (

;;ƍ
	 (width (car (gimp-drawable-width drawable)))
	 (height (car (gimp-drawable-height drawable)))

;;wiȂ
	 (bg-layer (car (gimp-layer-new img (+ width (/ sinpuku 0.5)) height RGB-IMAGE "Background" 100 NORMAL-MODE)))
	 (grad-layer (car (gimp-layer-new img (+ width (/ sinpuku 0.5)) height RGB-IMAGE "Background" 100 NORMAL-MODE)))

         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))

;;2.4ǉ
	 (h-layer)
	 (kansei)

         )

    (gimp-image-undo-group-start img)

(if (= FALSE text?)
(begin
    (gimp-image-resize img (+ (+ width (/ sinpuku 0.4)) 6) (+ (+ height (/ hachou 3)) 54) (+ (/ sinpuku 0.8) 2) (+ (/ hachou 10) 47))		;add
    (gimp-layer-resize drawable (+ (+ width (/ sinpuku 0.4)) 6) (+ (+ height (/ hachou 3)) 54) (+ (/ sinpuku 0.8) 2) (+ (/ hachou 10) 47))	;add
    )
(begin
    (gimp-image-resize img (+ width (/ sinpuku 0.5)) height (/ sinpuku 1) 0)		;add
    (gimp-layer-resize drawable (+ width (/ sinpuku 0.5)) height (/ sinpuku 1) 0)	;add
    ))

;;̐F͔
    (gimp-palette-set-background '(255 255 255))
    (gimp-selection-layer-alpha drawable)
    (gimp-edit-fill drawable BACKGROUND-FILL)

    (set! h-layer (car (gimp-layer-copy drawable 0)))
    (gimp-selection-grow img 3)
    (gimp-selection-feather img 10)
    (gimp-palette-set-background '(255 255 255))
    (gimp-edit-fill drawable BACKGROUND-FILL)
    (gimp-selection-none img)
    (gimp-image-rotate img 0)
    (plug-in-wind 1 img drawable 10 0 10 0 0)
    (gimp-image-rotate img 2)
    (plug-in-ripple 1 img drawable hachou sinpuku 0 0 1 1 1)
    (gimp-image-add-layer img grad-layer 0)
    (if (= FALSE text?) (gimp-layer-resize grad-layer (+ (+ width (/ sinpuku 0.4)) 6) (+ (+ height (/ hachou 3)) 54) 0 0))	;add
    (gimp-layer-set-mode grad-layer 13)
    (if (= gmode 1)
        (gimp-layer-set-mode grad-layer 4))
    (gimp-gradients-set-gradient text-gradient)
    (gimp-blend grad-layer CUSTOM-MODE NORMAL-MODE GRADIENT-LINEAR 100 20 REPEAT-NONE
                                                FALSE 0 0 0 0 0 0 0 (* gg height))
    (gimp-brightness-contrast grad-layer 30 0)
    (gimp-image-add-layer img h-layer 1)
    (if (= lmode 0)
        (gimp-layer-set-mode h-layer 5))
;    (set! hh-layer (car (gimp-layer-copy h-layer 0)))
;    (gimp-image-add-layer img hh-layer 1)
    (plug-in-gauss-iir2 1 img h-layer tblur tblur)


;;wiF̌(bg-layeř̐̓C[̏Ԃł)
    (gimp-palette-set-background '(0 0 0))
    (gimp-image-add-layer img bg-layer 3)
    (if (= FALSE text?) (gimp-layer-resize bg-layer (+ (+ width (/ sinpuku 0.4)) 6) (+ (+ height (/ hachou 3)) 54) 0 0))	;add
    (gimp-drawable-fill bg-layer BACKGROUND-FILL)

;;摜̓
   (if(= merge? TRUE)
     (set! kansei (car (gimp-image-flatten img))))

    (gimp-palette-set-background old-bg)
    (gimp-gradients-set-gradient old-grad)

    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
))

(define (script-fu-mhfire-imgh img drawable text-gradient hachou sinpuku tblur lmode gmode gg merge?)
(script-fu-mhfire-img img drawable text-gradient hachou sinpuku tblur lmode gmode gg merge? FALSE)
)

(script-fu-register "script-fu-mhfire-imgh"
		    "<Image>/Script-Fu/MH/fire"
		    "mhfire-img"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    "RGBA"
		    SF-IMAGE       "Image" 0
		    SF-DRAWABLE    "Drawable" 0
                    SF-GRADIENT    "Gradient"          "German flag smooth"
		    SF-ADJUSTMENT _"period"            '(20 1 50 1 2 0 0)
		    SF-ADJUSTMENT _"amplitude"           '(3 0 20 1 2 0 0)
		    SF-ADJUSTMENT _"Text-blur"         '(5 0 50 1 2 0 0)
                    SF-OPTION      "textlayer-mode"    '(_"overlay" _"normal")
                    SF-OPTION      "gradlayer-mode"    '(_"color" _"screen")
		    SF-ADJUSTMENT _"grad-length"       '(0.7 0 1 0.01 0.02 2 0)
                    SF-TOGGLE      "Flatten Image"      TRUE)


(define (script-fu-mhfire text size font text-gradient hachou sinpuku tblur lmode gmode gg merge?)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 12) 4) TRUE size PIXELS font)))
;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))
         (hheight(* height 1.7))

         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))
         )

    (gimp-image-undo-disable img)

;;TCY
    (gimp-image-resize img width hheight 0 (- hheight height))
    (gimp-layer-resize text-layer width hheight 0 (- hheight height))

    (script-fu-mhfire-img img text-layer text-gradient hachou sinpuku tblur lmode gmode gg merge? TRUE)

    (gimp-image-undo-enable img)
    (gimp-display-new img)
))


(script-fu-register "script-fu-mhfire"
		    "<Image>/File/Create/Logos/Burning Fire..."
		    "mhfire"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    ""
		    SF-STRING      "Text String"       "Burning Fire!!!"
		    SF-ADJUSTMENT  "Font Size (pixels)" '(100 2 1000 1 10 0 1)
		    SF-FONT        "Font"              "Sans Bold"
                    SF-GRADIENT    "Gradient"          "German flag smooth"
		    SF-ADJUSTMENT _"period"            '(20 1 50 1 2 0 0)
		    SF-ADJUSTMENT _"amplitude"           '(3 0 20 1 2 0 0)
		    SF-ADJUSTMENT _"Text-blur"         '(3 1 50 1 2 0 0)
                    SF-OPTION      "textlayer-mode"    '(_"overlay" _"normal")
                    SF-OPTION      "gradlayer-mode"    '(_"color" _"screen")
		    SF-ADJUSTMENT _"grad-length"       '(0.7 0 1 0.01 0.02 2 0)
                    SF-TOGGLE      "Flatten Image"      TRUE)
