;;mhplasticimg
;Kiki
;http://kikidide.yuki-mura.net/GIMP/gimp.htm
;http://kikidide.yuki-mura.net/GIMP/engimp.htm
;

(define (script-fu-mhplasticimg iii drawable text-color md meido trans)
  (let* ((image (car (gimp-image-new 256 256 RGB)))

;;摜̃Rs[
         (img (car (gimp-image-duplicate iii)))

;;image(}bv)layer
         (ilayer (car (gimp-layer-new image 256 256 RGB-IMAGE "map" 100 NORMAL-MODE)))

;;ƍ
         (width (car (gimp-image-width img)))
         (height (car (gimp-image-height img)))

;;imgɒǉ郌C[(GRAYA̓At@`l̂ƁBC[폜œɂł)
         (imglayer (car (gimp-layer-new img width height GRAYA-IMAGE "dm" 100 NORMAL-MODE)))

;;摜
         (ptext (car (gimp-image-new width height RGB)))
         (dd (car (gimp-layer-new ptext width height RGB-IMAGE "ptext" 100 NORMAL-MODE)))
;;wi
	 (gg-layer (car (gimp-layer-new ptext width height RGB-IMAGE "Background" 100 NORMAL-MODE)))

         (old-bg (car (gimp-palette-get-background)))
         (old-grad (car (gimp-gradients-get-gradient)))
)
    (gimp-image-undo-disable ptext)
    (gimp-image-convert-grayscale img)                     ;O[XP[
    (gimp-image-add-layer img imglayer 0)                  ;C[ǉ
    (gimp-selection-all img)
    (gimp-edit-clear imglayer)                             ;I𕔕폜(ǉC[̂)
    (gimp-selection-none img)
    (set! iill (car (gimp-image-flatten img)))             ;mergeƃCgʂŃG[ɂȂI
;;;    (plug-in-gauss-iir2 1 img iill 5 5)

;;}bv̍쐬
    (gimp-image-add-layer image ilayer 0)
    (gimp-palette-set-background text-color)               ;hԂ
    (gimp-drawable-fill ilayer BACKGROUND-FILL)

;;쐬
    (gimp-image-add-layer ptext dd 0)
    (gimp-palette-set-background '(0 0 0)) ;;ǉ
    (gimp-edit-fill dd BACKGROUND-FILL)	   ;;ǉ
    (plug-in-lighting 1 ptext dd iill ilayer TRUE TRUE md 1 '(255 255 255) 0 0 0 0.5 0.5 0.5 0.3 (+ (/ meido 7.5) 0.543) 0.4 0 27 FALSE FALSE trans)
    (gimp-brightness-contrast dd 60 -30)
    (gimp-hue-saturation dd 0 0 0 40)

    (gimp-image-delete img)
    (gimp-image-delete image)

    (gimp-palette-set-background old-bg)
    (gimp-gradients-set-gradient old-grad)

    (gimp-image-undo-enable ptext)
    (if (= trans FALSE) (gimp-display-new ptext))
))

(script-fu-register "script-fu-mhplasticimg"
		    "<Image>/Script-Fu/MH/plastic"
		    "mhplasticimg"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    "RGB*"
		    SF-IMAGE       "Image"     0
		    SF-DRAWABLE    "Drawable"  0
                    SF-COLOR       "COLOR"            '(222 222 255)
                    SF-OPTION      "mode"             '(_"normal" _"flat?")
		    SF-ADJUSTMENT  "light"   '(0.5 -1.5 1.5 0.01 0.02 2 0)
                    SF-TOGGLE      "black transparent?"   FALSE)


;;mhplastic
;;Kiki

(define (script-fu-mhplastic text size font text-color md noise? ns meido bmode bcolor bgrad btex)
  (let* ((img (car (gimp-image-new 256 256 GRAY)))
         (image (car (gimp-image-new 256 256 RGB)))

         (old-bg (car (gimp-palette-get-background)))
         (old-fg (car (gimp-palette-get-foreground)))
         (old-grad (car (gimp-gradients-get-gradient)))
         (old-pat (car (gimp-patterns-get-pattern)))

         (tmp (car (gimp-palette-set-foreground '(  0   0   0))))	;add
         (tmp1 (car (gimp-palette-set-background '(255 255 255))))	;add

;;imagelayer
         (ilayer (car (gimp-layer-new image 256 256 RGB-IMAGE "map" 100 NORMAL-MODE)))

;;
	 (text-layer (car (gimp-text-fontname img -1 0 0 text (+ (/ size 10) 5) TRUE size PIXELS font)))

;;ƍ
	 (width (car (gimp-drawable-width text-layer)))
	 (height (car (gimp-drawable-height text-layer)))

;;vXeBbN̉摜(t2-layer͕Ip)
         (ptext (car (gimp-image-new width height RGB)))
         (dd (car (gimp-layer-new ptext width height RGBA-IMAGE "ptext" 100 NORMAL-MODE)))
;;;;;	 (t2-layer (car (gimp-text-fontname ptext -1 0 0 text (+ (/ size 10) 5) TRUE size PIXELS font)))
	 (t2-layer (car (gimp-layer-copy text-layer 0)))

;;wi
	 (bg-layer (car (gimp-layer-new img width height GRAYA-IMAGE "Background" 100 NORMAL-MODE)))
	 (gg-layer (car (gimp-layer-new ptext width height RGB-IMAGE "Background" 100 NORMAL-MODE)))
	 (bg (car (gimp-layer-new ptext width height RGB-IMAGE "BG" 100 NORMAL-MODE)))
)
(gimp-image-undo-disable ptext)

;;}bv̍쐬
    (gimp-image-add-layer image ilayer 0)
    (gimp-palette-set-background text-color)               ;hԂ
    (gimp-drawable-fill ilayer BACKGROUND-FILL)

;;̍쐬
    (gimp-image-resize img width height 0 0)               ;TCY
    (gimp-palette-set-background '(255 255 255))           ;œhԂ
    (gimp-layer-set-preserve-trans text-layer TRUE)
    (gimp-edit-fill text-layer BACKGROUND-FILL)
    (gimp-palette-set-background '(0 0 0))                 ;œhԂ
    (gimp-image-add-layer img bg-layer 1)
    (gimp-drawable-fill bg-layer BACKGROUND-FILL)
    (set! tt1 (car (gimp-image-merge-down img text-layer 1)))    ;C[ĖO
    (if (> size 119) (plug-in-gauss-iir2 1 img tt1 (*  (/ size 120) 5) (*  (/ size 120) 5))	;ڂ
	(plug-in-gauss-iir2 1 img tt1 5 5))
    (if (= noise? TRUE) (plug-in-noisify 1 img tt1 0 ns ns 0 0))
    (set! tt (car (gimp-image-flatten img)))

;;vXeBbN쐬
    (gimp-image-add-layer ptext dd 0)
    (gimp-edit-fill dd BACKGROUND-FILL)	 			;;ǉ
    (plug-in-lighting 1 ptext dd tt ilayer TRUE TRUE md 1 '(255 255 255) 0 0 0 0.5 0.5 0.5 0.3 (+ (/ meido 7.5) 0.543) 0.4 0 27 FALSE FALSE FALSE)
    (gimp-brightness-contrast dd 65 -15)
    (gimp-hue-saturation dd 0 0 0 40)

(if (> bmode 0)
(begin
    (set! tg-layer (car (gimp-layer-new ptext width height RGBA-IMAGE "tglayer" 100 NORMAL-MODE)))
    (gimp-image-add-layer ptext tg-layer 0)
    (gimp-image-add-layer img t2-layer 0)
    (gimp-palette-set-background '(255 255 255))	;add
    (gimp-selection-layer-alpha t2-layer)		;add
    (gimp-selection-invert img)				;add
    (gimp-edit-fill t2-layer BACKGROUND-FILL)		;add
    (gimp-edit-clear tg-layer)
    (gimp-selection-all img)
    (gimp-edit-copy t2-layer)
      (let ((floating-sel (car (gimp-edit-paste tg-layer FALSE))))
	(gimp-floating-sel-anchor floating-sel))
;    (gimp-selection-layer-alpha tg-layer)		;sI(none)
    (gimp-by-color-select tg-layer '(0 0 0) 0 REPLACE FALSE 0 0 FALSE)	;black selection(add)
    (gimp-selection-grow ptext (*  (/ size 200) 5))	;I𕔕g
    (gimp-selection-feather ptext (*  (/ size 200) 5))	;Eڂ
    (gimp-selection-invert ptext)                          ;I͈͂𔽓]
    (gimp-edit-clear dd)                                   ;I𕔕폜
    (gimp-selection-none ptext)                            ;I
    (gimp-image-remove-layer ptext tg-layer)
    (gimp-image-remove-layer img t2-layer)
))

(if (> bmode 1)						;wiǉ
(begin
    (gimp-image-add-layer ptext bg 1)
    (gimp-palette-set-background bcolor)
    (gimp-edit-fill bg BACKGROUND-FILL)			;hԂ
    (cond((= bmode 3)
       (gimp-gradients-set-gradient bgrad)
       (gimp-edit-blend bg CUSTOM NORMAL LINEAR 100 20 REPEAT-NONE
                                            FALSE FALSE 0 0 FALSE 0 0 0 height))
       ((= bmode 4)
       (gimp-patterns-set-pattern btex)
       (gimp-edit-bucket-fill bg PATTERN-BUCKET-FILL NORMAL-MODE 100 255 FALSE 0 0)
     ))
))
;;    (gimp-image-merge-visible-layers ptext 0)

    (gimp-image-delete img)
    (gimp-image-delete image)

    (gimp-palette-set-background old-bg)
    (gimp-palette-set-foreground old-fg)
    (gimp-gradients-set-gradient old-grad)
    (gimp-patterns-set-pattern old-pat)

    (gimp-image-undo-enable ptext)
    (gimp-display-new ptext)
))

(script-fu-register "script-fu-mhplastic"
		    "<Image>/File/Create/Logos/Plastic..."
		    "mhplastic"
		    "Kiki"
		    "Kiki"
		    "2005/1"
		    ""
		    SF-STRING      "Text String"      "HomePage"
		    SF-ADJUSTMENT  "Font Size (pixels)" '(120 10 1000 1 10 0 1)
		    SF-FONT        "Font"             "Megadeth"
                    SF-COLOR       "COLOR"            '(222 222 255)
                    SF-OPTION      "mode"             '(_"normal" _"flat?")
                    SF-TOGGLE      "noise?"           FALSE
		    SF-ADJUSTMENT  "noise"            '(0.01 0.01 1 0.01 0.02 2 0)
		    SF-ADJUSTMENT  "light"          '(0.5 -1.5 1.5 0.01 0.02 2 0)
                    SF-OPTION      "background-mode"  '(_"plastic" _"transparent" _"color" _"gradient" _"pattern")
                    SF-COLOR       "Color"            '(213 143 187)
                    SF-GRADIENT    "Gradient"         "Land 1"
                    SF-PATTERN     "Pattern"          "Pool Bottom"
)
